Attribute VB_Name = "mCore"
Option Explicit

'Types
    Type tCoord2D
        x As Long
        y As Long
    End Type
    
    Type tCoord2DFloat
        x As Single
        y As Single
    End Type

'Vars
    Global Active As Boolean
    Global Path As String

    Global Logged As String
    Global LogDepth As Long
    
    Global Camera As New cCamera
    
    'FPS
    Global FPS As Long
    Global StartTime As Long
    Global FrameCount As Long
    
    Public DirectX As New DirectX8

    Dim QQ As Long
Public Sub GetFPS()
    FrameCount = FrameCount + 1
    If StartTime < GetTickCount() Then
        FPS = FrameCount
        
        StartTime = GetTickCount + 1000
        FrameCount = 0
    End If
End Sub

Public Sub LOADTEMP()
    Dim A As Long
    
    Randomize
    
    Level.Size.x = 32
    Level.Size.y = 1000
    Level.Parallax = 2
    Level.Tiles = "Graphic\Test.def"
    Level.Speed.y = 1
    
    ReDim Level.Map(Level.Size.x * Level.Size.y)

    For A = 0 To Level.Size.x * Level.Size.y
        Level.Map(A).Sky = IIf(1000 * Rnd < 950, 0, 1)

        If 1000 * Rnd < 950 Then
            Level.Map(A).Floor = -1
        Else
            Level.Map(A).Floor = 2
        End If

        If 1000 * Rnd < 5 Then
            Level.Map(A).Enemy = 1
        Else
            Level.Map(A).Enemy = -1
        End If
    Next
    'LoadLevel "Levels\Test.def"
    
    TileCount = 2
    ReDim Tile(TileCount)

    Tile(0).Bitmap = LoadBitmap("Graphic\Black.bmp")
    Tile(1).Bitmap = LoadBitmap("Graphic\Star.bmp")
    With Bitmap(Tile(1).Bitmap).Animation
        .Enabled = True
        .PhaseCount.x = 3
        .Speed = 200
    End With

    Tile(2).Bitmap = LoadBitmap("Graphic\Star2.bmp")
    With Bitmap(Tile(2).Bitmap).Animation
        .Enabled = True
        .PhaseCount.x = 3
        .Speed = 200
    End With
    'LoadTiles Level.Tiles
'    SaveTiles Level.Tiles
    
    SrcShotCount = 5
    ReDim SrcShot(SrcShotCount)

    With SrcShot(0)
        .Bitmap = LoadBitmap("Graphic\Shot.bmp")
        .Energy = 0.2
        .Size.x = 5
        .Size.y = 5

        .Speed.y = -6
        .DieTime = 1000

        .FollowTarget = True
        .MaxSpeed.x = 4
        .MaxSpeed.y = 4

        .Acceleration.x = 0.5
        .Acceleration.y = 0.5

        With Bitmap(.Bitmap).Animation
            .Enabled = True
            .PhaseCount.x = 3
            .Speed = 200
        End With
    End With

    With SrcShot(1)
        .Bitmap = LoadBitmap("Graphic\SonicL.bmp")
        .Energy = 1
        .Size.x = 9
        .Size.y = 25
        .Speed.x = -4
        .DieTime = 1000
    End With

    With SrcShot(2)
        .Bitmap = LoadBitmap("Graphic\SonicR.bmp")
        .Energy = 1
        .Size.x = 9
        .Size.y = 25
        .Speed.x = 4
        .DieTime = 1000
    End With

    With SrcShot(3)
        .Bitmap = LoadBitmap("Graphic\Shot.bmp")
        .Energy = 1
        .Size.x = 5
        .Size.y = 5
        .Speed.x = -4
        .Speed.y = -4
        .DieTime = 1000

        .FollowTarget = True
        .MaxSpeed.x = 4
        .MaxSpeed.y = 4

        With Bitmap(.Bitmap).Animation
            .Enabled = True
            .PhaseCount.x = 3
            .Speed = 200
        End With
    End With

    With SrcShot(4)
        .Bitmap = LoadBitmap("Graphic\Shot.bmp")
        .Energy = 1
        .Size.x = 5
        .Size.y = 5
        .Speed.x = 4
        .Speed.y = -4
        .DieTime = 1000

        .FollowTarget = True
        .MaxSpeed.x = 4
        .MaxSpeed.y = 4

        With Bitmap(.Bitmap).Animation
            .Enabled = True
            .PhaseCount.x = 3
            .Speed = 200
        End With
    End With

    With SrcShot(5)
        .Bitmap = LoadBitmap("Graphic\Laser.bmp")
        .Energy = 2
        .Size.x = 6
        .Size.y = 48
        .Speed.y = -.Size.y
        .DieTime = 1000
    End With

    'LoadShots "Shots\Test.def"
    
    SrcWeaponCount = 6
    ReDim SrcWeapon(SrcWeaponCount)

    With SrcWeapon(0)
        .Sound = "Sound\Laser.wav"
        .SoundChannel = 0

        .Interval = 100
        .Shot = 0
        .ShotPosition.x = 16
        .ShotPosition.y = 4
    End With

    With SrcWeapon(1)
        .Interval = 100
        .Shot = 0
        .ShotPosition.x = 32
        .ShotPosition.y = 4
    End With

    With SrcWeapon(2)
        .Interval = 200
        .Shot = 1
        .ShotPosition.x = 0
        .ShotPosition.y = 48
    End With

    With SrcWeapon(3)
        .Interval = 200
        .Shot = 2
        .ShotPosition.x = 48
        .ShotPosition.y = 48
    End With

    With SrcWeapon(4)
        .Interval = 100
        .Shot = 3
        .ShotPosition.x = 12
        .ShotPosition.y = 24
    End With

    With SrcWeapon(5)
        .Interval = 100
        .Shot = 4
        .ShotPosition.x = 36
        .ShotPosition.y = 24
    End With

    With SrcWeapon(6)
        .Interval = 0
        .Shot = 5
        .ShotPosition.x = 24
        .ShotPosition.y = 24
    End With
    
    'LoadWeapons "Weapons\Test.def"
    
    SrcShipCount = 1
    ReDim SrcShip(SrcShipCount)
    
    With SrcShip(0)
        .Bitmap = LoadBitmap("Graphic\Ship.bmp")
        .Index = 0
        .Size.x = 48
        .Size.y = 64
        .Position.y = Camera.H - 72
        .Position.x = Camera.W / 2 - 24
        
        .FlameSize.x = 48
        .FlameSize.y = 48
        .FlamePosition.x = 0
        .FlamePosition.y = 64
        
        .MaxSpeed.x = 3
        .MaxSpeed.y = 3
        .Acceleration.x = 0.15
        .Acceleration.y = 0.15
        
        .WeaponCount = -1
        SetWeapon SrcShip(0), 0
        SetWeapon SrcShip(0), 1
        SetWeapon SrcShip(0), 2
        SetWeapon SrcShip(0), 3
        SetWeapon SrcShip(0), 4
        SetWeapon SrcShip(0), 5
        SetWeapon SrcShip(0), 6
        
        .MaxEnergy = 100
        .Energy = 100
        .ShotRange.x = 400
        .ShotRange.y = 300
        
        .Flame = LoadBitmap("Graphic\Flame.bmp")
        With Bitmap(.Flame).Animation
            .Enabled = True
            .PhaseCount.x = 1
            .Speed = 100
        End With
    End With
    
    With SrcShip(1)
        .Dest = 1
        
        .Index = 1
        .Bitmap = LoadBitmap("Graphic\Enemy.bmp")
        .Size.x = 48
        .Size.y = 64
                
        .FlameSize.x = 48
        .FlameSize.y = 48
        .FlamePosition.x = 0
        .FlamePosition.y = -48
        
        .MaxSpeed.x = 1
        .MaxSpeed.y = 1
        .Acceleration.x = 0.1
        .Acceleration.y = 0.1
        
        .FollowTarget = True
        .Target = 0
        .HasTarget = True
        
        .WeaponCount = -1
        SetWeapon SrcShip(1), 0
        
        .MaxEnergy = 100
        .Energy = 100
        .ShotRange.x = 200
        .ShotRange.y = 300
        
        .Flame = LoadBitmap("Graphic\EnemyFlame.bmp")
        With Bitmap(.Flame).Animation
            .Enabled = True
            .PhaseCount.x = 1
            .Speed = 100
        End With
    End With
    
    'SaveShips "Ships\Test.def"
    
    AddShip 0
    Ship(0).Player = True

    'frmMain.MM1.FileName = Path & "Sound\Back.mid"
    'frmMain.MM1.Command = "Open"
    'frmMain.MM1.Command = "Play"
    
    Camera.y = (Level.Size.y - Camera.TilesY - 1) * TileH
End Sub
Public Sub ShutDown()
    'Shutdown
    Log "Shutting down engine", 3
    
    'SaveLevel "Levels\Test.def"
    
    'Reset all
    ResetTiles
    ResetShips
    ResetShots
    ResetWeapons
    frmMain.MM1.Command = "Stop"
    frmMain.MM1.Command = "Close"
    
    mDXGraphics.ShutDown
    mDSound.ShutDown
    
    'Exit to windows
    Log "Done", -3
    End
End Sub
Public Sub Log(iText As String, Optional iDepth As Long = 0)
    'Apply text
    Logged = Logged & String(LogDepth, " ") & IIf(iDepth > 0, "+", "-") & " " & iText & vbNewLine
    
    'Log to textbox
    frmLog.txtLog.Text = Logged
    frmLog.txtLog.SelStart = Len(Logged)
    
    'Check depth
    LogDepth = LogDepth + iDepth
    If LogDepth < 0 Then: LogDepth = 0
    
    'Update window
    frmLog.Refresh
End Sub
Public Sub Main()
    Path = App.Path & IIf(Right(App.Path, 1) = "\", "", "\")
    
    'Load game
    frmLog.Show , frmMain
    Log "Loading game", 3
    
    'Create back buffer
    Log "BackBuffer..."
    Camera.W = frmMain.ScaleWidth
    Camera.H = frmMain.ScaleWidth
    frmMain.Front.Move 0, 0, Camera.W, Camera.H
    
    'Reset all
    Log "Modules..."
    BitmapCount = -1
    ResetTiles
    ResetShips
    ResetShots
    ResetWeapons
    
    FPS = 100
    StartTime = GetTickCount + 5000
    
    Camera.Init
    
    mDXGraphics.Initialize
    mDXGraphics.InitWindowed frmMain.Front.hWnd
    mDSound.Initialize
    
    LOADTEMP
    
    'Loaded
    Log "Done", -3
    frmMain.Show
    frmLog.Hide
    
    Active = True
    MainLoop
End Sub
Function Exists(iFilename As String) As Boolean
    Exists = Not (Dir(iFilename, vbArchive Or vbHidden Or vbNormal Or vbReadOnly Or vbSystem) = "")
End Function

Public Sub MainLoop()
    While Active = True
        CheckInput
        
        MoveShips
        MoveShots
        
        AnimateBitmaps
        
        BeginScene
        
'        If FPS > 20 Then
            DrawLevel Level
            DrawShips
            DrawShots
'        End If
        
        'Flip
        EndScene
        GetFPS
        
        'Scroll
        Camera.y = Camera.y - Level.Speed.y
        If Camera.y <= 0 Then
            MsgBox "You did it!", vbInformation, "Congratulations!"
            Active = False
        End If
        
        If Not frmMain.Caption = CStr(FPS) Then: frmMain.Caption = CStr(FPS)
    
        DoEvents
    Wend
    
    ShutDown
End Sub
