Attribute VB_Name = "mDSound"
Option Explicit

'Variables
    Public DSound As DirectSound8
    
    Public SoundCount As Long
    Public Sound() As DirectSoundSecondaryBuffer8
    Private SoundFile() As String
Public Sub Initialize()
On Error GoTo 1
    
    'Init variables
    SoundCount = -1
    
    'Create main object
    Set DSound = DirectX.DirectSoundCreate("")
    If DSound Is Nothing Then: GoTo 1
    
    'Set cooperation level
    DSound.SetCooperativeLevel frmMain.hWnd, DSSCL_PRIORITY
    Exit Sub
    
1  'Error
    ShutDown
End Sub

Public Function AddSound(iFilename As String, Optional iForceLoad As Boolean) As Long
    Dim A As Long
    
    Dim Temp As Long
    Dim SoundDesc As DSBUFFERDESC
        
    If Not Exists(iFilename) Then
        'Error: File not found
        AddSound = -1
        
        Exit Function
    End If
    
    If Not iForceLoad Then
        For A = 0 To SoundCount
            'Check if already loaded
            If StrComp(SoundFile(A), iFilename, vbTextCompare) = 0 Then
                AddSound = A
                
                Exit Function
            End If
        Next
    End If
    
    'Allocate memory
    Temp = CreateSound
    
    'Enable frequency and volume control
    SoundDesc.lFlags = DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLVOLUME
    
    'Load sound buffer
    Set Sound(Temp) = DSound.CreateSoundBufferFromFile(iFilename, SoundDesc)
    SoundFile(Temp) = iFilename
    
    'Return index
    AddSound = Temp
End Function
Private Function CreateSound() As Long
    'Allocate memory
    SoundCount = SoundCount + 1
    ReDim Preserve Sound(SoundCount)
    ReDim Preserve SoundFile(SoundCount)
    
    'Return index
    CreateSound = SoundCount
End Function
Public Sub PlaySound(iFilename As String, iLoop As Boolean)
    Dim Temp As Long
    
    Temp = AddSound(iFilename)
    If Temp < 0 Then: Exit Sub
    
    If iLoop Then
        Sound(Temp).Play DSBPLAY_LOOPING
    Else
        Sound(Temp).Play DSBPLAY_DEFAULT
    End If
End Sub

Public Sub ShutDown()
    Dim A As Long
    
    'Release sounds
    For A = 0 To SoundCount: Set Sound(A) = Nothing: Next
    Erase Sound
    Erase SoundFile
    
    'Release object
    Set DSound = Nothing
End Sub

