Attribute VB_Name = "mLevel"
Option Explicit

'Types
    Type tMap
        Sky As Integer
        Floor As Integer
        
        Enemy As Long
        Done As Boolean
    End Type

    Type tLevel
        Size As tCoord2D 'Size of map array
        
        Tiles As String 'FileName
        Map() As tMap
        
        Parallax As Long
        
        Speed As tCoord2DFloat
    End Type

'Vars
    Global Level As tLevel
Public Sub DrawLevel(iLevel As tLevel)
    Dim A As Long
    Dim B As Long
    
    Dim Index As Long
    Dim Temp As Long
    
    Dim TempX As Single
    Dim TempY As Single
    
    'Draw sky
    TempX = (Camera.x / TileW) / iLevel.Parallax
    TempY = (Camera.y / TileH) / iLevel.Parallax
    
    Index = Int(TempY) * iLevel.Size.x + Int(TempX)
    
    TempX = (TempX - Int(TempX))
    TempY = (TempY - Int(TempY))
    
    'Disable masking
    Device.SetRenderState D3DRS_ALPHATESTENABLE, 0
    
    For B = 0 To Camera.TilesY
        For A = 0 To Camera.TilesX
            Temp = iLevel.Map(Index).Sky
            With Bitmap(Tile(Temp).Bitmap)
                BltToBuffer .Texture, (A - TempX) * TileW, (B - TempY) * TileH, CSng(TileW), CSng(TileH), Tile(Temp).Position.x + .Animation.ActPhase.x * TileW, Tile(Temp).Position.y + .Animation.ActPhase.y * TileH, CSng(TileW), CSng(TileH)
            End With

            Index = Index + 1
        Next
        
        Index = Index + iLevel.Size.x - Camera.TilesX - 1
    Next
    
    BltBuffers
    
    'Draw floor
    TempX = (Camera.x / TileW)
    TempY = (Camera.y / TileH)

    Index = Int(TempY) * iLevel.Size.x + Int(TempX)

    TempX = (TempX - Int(TempX))
    TempY = (TempY - Int(TempY))
    
    'Disable masking
    Device.SetRenderState D3DRS_ALPHATESTENABLE, 1

    For B = 0 To Camera.TilesY
        For A = 0 To Camera.TilesX
            Temp = iLevel.Map(Index).Floor
            If Temp <> -1 Then
                With Bitmap(Tile(Temp).Bitmap)
                    BltToBuffer .Texture, (A - TempX) * TileW, (B - TempY) * TileH, CSng(TileW), CSng(TileH), Tile(Temp).Position.x + .Animation.ActPhase.x * TileW, Tile(Temp).Position.y + .Animation.ActPhase.y * TileH, CSng(TileW), CSng(TileH)
                End With
            End If

            Index = Index + 1
        Next

        Index = Index + iLevel.Size.x - Camera.TilesX - 1
    Next
    
    BltBuffers
End Sub
Public Sub SaveLevel(iFilename As String)
    Dim FileNumber As Integer

    FileNumber = FreeFile
    
    Open Path & iFilename For Binary As FileNumber
        With Level
            Put FileNumber, , .Size
            Put FileNumber, , .Map
            Put FileNumber, , .Parallax
            Put FileNumber, , .Speed
            Put FileNumber, , Len(.Tiles)
            Put FileNumber, , .Tiles
        End With
    Close FileNumber
End Sub


Public Sub LoadLevel(iFilename As String)
    Dim FileNumber As Integer
    Dim Temp As Long

    FileNumber = FreeFile
    
    Open Path & iFilename For Binary As FileNumber
        With Level
            Get FileNumber, , .Size
            ReDim .Map(.Size.x * .Size.y)
            
            Get FileNumber, , .Map
            Get FileNumber, , .Parallax
            Get FileNumber, , .Speed
            Get FileNumber, , Temp
            .Tiles = Space(Temp)
            Get FileNumber, , .Tiles
        End With
    Close FileNumber
End Sub

