Attribute VB_Name = "mShip"
Option Explicit

'Types
    Type tShip
        Name As String
        Index As Long
        
        Bitmap As Long
        Size As tCoord2D
        Position As tCoord2DFloat
        
        'Flame
        Flame As Long
        FlamePosition As tCoord2D
        FlameSize As tCoord2D
        
        'Weapons
        WeaponCount As Long
        Weapon() As tWeapon
        
        Player As Boolean
        
        'Movement
        Speed As tCoord2DFloat
        Acceleration As tCoord2DFloat
        MaxSpeed As tCoord2DFloat
        
        FollowTarget As Boolean
        HasTarget As Boolean
        Target As Long
        
        'Game
        Energy As Single
        MaxEnergy As Long
        ShotRange As tCoord2D
        
        Dest As Long
    End Type

'Vars
    Global ShipCount As Long
    Global Ship() As tShip
    
    Global SrcShipCount As Long
    Global SrcShip() As tShip
Public Sub AddShip(iShip As Long)
    ShipCount = ShipCount + 1
    ReDim Preserve Ship(ShipCount)
    
    Ship(ShipCount) = SrcShip(iShip)
End Sub


Function FindTarget(iOwner As Long) As Long
    Dim A As Long
    
    FindTarget = -1
    For A = 0 To ShipCount
        If A <> iOwner Then
            If Ship(A).Position.x > Ship(iOwner).Position.x - Ship(iOwner).ShotRange.x And Ship(A).Position.x < Ship(iOwner).Position.x + Ship(iOwner).Size.x + Ship(iOwner).ShotRange.x Then
                If Ship(A).Position.y > Ship(iOwner).Position.y - Ship(iOwner).ShotRange.y And Ship(A).Position.y < Camera.H Then
                    FindTarget = A
                    
                    Exit Function
                End If
            End If
        End If
    Next
End Function

Public Sub Hit(iShip As Long, iShot As Long)
    Ship(iShip).Energy = Ship(iShip).Energy - Shot(iShot).Energy
    
    If Ship(iShip).Energy <= 0 Then
        Ship(iShip) = Ship(ShipCount)
        ShipCount = ShipCount - 1
        
        If iShip = 0 Then
            MsgBox "You lose!", vbCritical, "Ha-ha!"
            
            Active = False
        End If
    End If
End Sub

Public Sub SaveShips(iFilename As String)
    Dim A As Long
    Dim FileNumber As Integer

    FileNumber = FreeFile
    
    Open Path & iFilename For Binary As FileNumber
        Put FileNumber, , SrcShipCount
        For A = 0 To SrcShipCount
            With SrcShip(A)
                Put FileNumber, , Len(Bitmap(.Bitmap).FileName)
                Put FileNumber, , Bitmap(.Bitmap).Animation
'                Put FileNumber, , Bitmap(.Bitmap).Size
                
                Put FileNumber, , .Size
                Put FileNumber, , Len(.Name)
                Put FileNumber, , .Name
                
                Put FileNumber, , Len(Bitmap(.Flame).FileName)
                Put FileNumber, , Bitmap(.Flame).Animation
'                Put FileNumber, , Bitmap(.Flame).Size
                
                Put FileNumber, , .FlamePosition
                Put FileNumber, , .FlameSize
                Put FileNumber, , .FollowTarget
                Put FileNumber, , .MaxEnergy
                Put FileNumber, , .MaxSpeed
                
                Put FileNumber, , .Acceleration
                Put FileNumber, , .Speed
                
                Put FileNumber, , .WeaponCount
                Put FileNumber, , .Weapon
                
                Put FileNumber, , .ShotRange
                Put FileNumber, , .Dest
            End With
        Next
    Close FileNumber
End Sub

Public Sub LoadShips(iFilename As String)
    Dim A As Long
    Dim FileNumber As Integer

    FileNumber = FreeFile
    
    Open Path & iFilename For Binary As FileNumber
        Get FileNumber, , SrcShipCount
        ReDim SrcShip(SrcShipCount)
        
        For A = 0 To SrcShipCount
            With SrcShip(A)
                
            End With
        Next
    Close FileNumber
End Sub
Public Sub ShipHit(iShip As Long, iValue As Long)
    Ship(iShip).Energy = Ship(iShip).Energy - iValue
    
    If Ship(iShip).Energy <= 0 Then
        Ship(iShip) = Ship(ShipCount)
        ShipCount = ShipCount - 1
        
        If iShip = 0 Then
            MsgBox "You lose!", vbCritical, "Ha-ha!"
            
            Active = False
        End If
    End If
End Sub

Public Sub MoveShips()
    Dim A As Long
    Dim B As Long
    Dim Temp As Long
    
    While A <= ShipCount
        With Ship(A)
            .Position.x = .Position.x + .Speed.x
            .Position.y = .Position.y + .Speed.y
            
            Bitmap(.Bitmap).Animation.ActPhase.y = 0
            If .Speed.x > 1 Then: Bitmap(.Bitmap).Animation.ActPhase.y = 3
            If .Speed.x > 1.5 Then: Bitmap(.Bitmap).Animation.ActPhase.y = 4
            If .Speed.x < -1 Then: Bitmap(.Bitmap).Animation.ActPhase.y = 1
            If .Speed.x < -1.5 Then: Bitmap(.Bitmap).Animation.ActPhase.y = 2
            
            Bitmap(.Flame).Animation.ActPhase.y = 0
            If .Speed.y < -0.5 Then: Bitmap(.Flame).Animation.ActPhase.y = 1
            If .Speed.y > 1 Then: Bitmap(.Flame).Animation.ActPhase.y = 2
        End With
        
        'Enemies
        If Ship(A).Player = True Then
            For B = 0 To ShipCount
                If B <> A Then
                    If Ship(A).Position.x + Ship(A).Size.x > Ship(B).Position.x And Ship(A).Position.x < Ship(B).Position.x + Ship(B).Size.x Then
                        If Ship(A).Position.y + Ship(A).Size.y > Ship(B).Position.y And Ship(A).Position.y < Ship(B).Position.y + Ship(B).Size.y Then
                            ShipHit A, 2
                            ShipHit B, 2
                            
                            Exit For
                        End If
                    End If
                End If
            Next
            
        Else
            Ship(A).Speed.y = 2
            
            If Ship(A).Position.y > Camera.y Or Ship(A).Position.x < -Ship(A).Size.x Or Ship(A).Position.x > Level.Size.x * TileW Then
                Ship(A) = Ship(ShipCount)
                ShipCount = ShipCount - 1
                
                A = A - 1
            
            Else
                With Ship(A)
                    If .HasTarget = True Then
                        If Ship(.Target).Position.x > .Position.x Then
                            .Speed.x = .Speed.x + .Acceleration.x
                            If .Speed.x > .MaxSpeed.x Then: .Speed.x = .MaxSpeed.x
                            
                        ElseIf Ship(.Target).Position.x < .Position.x Then
                            .Speed.x = .Speed.x - .Acceleration.x
                            If .Speed.x < -.MaxSpeed.x Then: .Speed.x = -.MaxSpeed.x
                        End If
                        
                        If Ship(.Target).Position.y > .Position.y Then
                            .Speed.y = .Speed.y + .Acceleration.y
                            If .Speed.y > .MaxSpeed.y Then: .Speed.y = .MaxSpeed.y
                            
                        ElseIf Ship(.Target).Position.y < .Position.y Then
                            .Speed.y = .Speed.y - .Acceleration.y
                            If .Speed.y < -.MaxSpeed.y Then: .Speed.y = -.MaxSpeed.y
                        End If
                    End If
                    
                    'Shoot
                    If FindTarget(A) <> -1 Then
                        For B = 0 To .WeaponCount
                            FireWeapon .Weapon(B)
                        Next
                    End If
                End With
            End If
        End If
        
        A = A + 1
    Wend
    
    'Add ships
    Temp = Int(Camera.y / TileH) * Level.Size.x
    
    For A = 0 To Camera.TilesX
        If Level.Map(Temp).Enemy <> -1 Then
            AddShip Level.Map(Temp).Enemy
            
            Level.Map(Temp).Enemy = -1
            
            Ship(ShipCount).Position.x = Camera.x + A * TileW
            Ship(ShipCount).Position.y = -(4 * TileH)
        End If
        
        Temp = Temp + 1
    Next
End Sub
Public Sub DrawShips()
    Dim A As Long
    
    'Disable masking
    Device.SetRenderState D3DRS_ALPHATESTENABLE, 1
    
    For A = 0 To ShipCount
        With Ship(A)
            BltToBuffer Bitmap(.Bitmap).Texture, (.Position.x - Camera.x), .Position.y, CSng(.Size.x), CSng(.Size.y), 0, Bitmap(.Bitmap).Animation.ActPhase.y * .Size.y, CSng(.Size.x), CSng(.Size.y)
            BltToBuffer Bitmap(.Flame).Texture, (.Position.x - Camera.x + .FlamePosition.x), (.Position.y + .FlamePosition.y), CSng(.FlameSize.x), CSng(.FlameSize.y), 0, Bitmap(.Flame).Animation.ActPhase.y * .FlameSize.y, CSng(.FlameSize.x), CSng(.FlameSize.y)
        End With
    Next
    
    BltBuffers
End Sub
Public Sub ResetShips()
    ShipCount = -1
    ReDim Ship(0)
    
    SrcShipCount = -1
    ReDim SrcShip(0)
End Sub


Public Sub SetWeapon(iShip As tShip, iWeapon As Long)
    iShip.WeaponCount = iShip.WeaponCount + 1
    ReDim Preserve iShip.Weapon(iShip.WeaponCount)
    
    iShip.Weapon(iShip.WeaponCount) = SrcWeapon(iWeapon)
    iShip.Weapon(iShip.WeaponCount).Ship = iShip.Index
End Sub
