Attribute VB_Name = "mShot"
Option Explicit

'Type
    Type tShot
        Bitmap As Long
        
        Size As tCoord2D
        DieTime As Long
        
        Owner As Long
        
        FollowTarget As Boolean
        HasTarget As Boolean
        Target As tShip
        
        Energy As Single
        
        Position As tCoord2DFloat
        Speed As tCoord2DFloat
        Acceleration As tCoord2DFloat
        MaxSpeed As tCoord2DFloat
    End Type

'Vars
    Global ShotCount As Long
    Global Shot() As tShot
    
    Global SrcShotCount As Long
    Global SrcShot() As tShot
Public Sub AddShot(iWeapon As tWeapon)
    Dim Temp As Long

    ShotCount = ShotCount + 1
    ReDim Preserve Shot(ShotCount)
    
    Shot(ShotCount) = SrcShot(iWeapon.Shot)
    
    With Shot(ShotCount)
        .Owner = iWeapon.Ship
        .Position.x = Ship(iWeapon.Ship).Position.x + iWeapon.ShotPosition.x - (.Size.x / 2)
        .Position.y = (Ship(iWeapon.Ship).Position.y + iWeapon.ShotPosition.y - (.Size.y / 2)) + (Ship(iWeapon.Ship).Dest * Ship(iWeapon.Ship).Size.y)
        
        If Ship(iWeapon.Ship).Dest = 1 Then
            .Speed.y = -.Speed.y
        End If

        If .FollowTarget = True Then
            Temp = FindTarget(Ship(iWeapon.Ship).Index)
            
            If Temp = -1 Then
                .HasTarget = False
            Else
                .Target = Ship(Temp)
                .HasTarget = True
            End If
        End If
        
        .DieTime = GetTickCount + .DieTime
    End With
End Sub

Public Sub MoveShots()
    Dim A As Long
    Dim B As Long
    Dim Temp As Long
    
    Temp = GetTickCount()
    
    While A <= ShotCount
        With Shot(A)
            .Position.x = .Position.x + .Speed.x
            .Position.y = .Position.y + .Speed.y
            
            If .HasTarget = True Then
                If .Target.Position.x + .Target.Size.x / 2 > .Position.x Then
                    .Speed.x = .Speed.x + .Acceleration.x
                    If .Speed.x > .MaxSpeed.x Then: .Speed.x = .MaxSpeed.x
                    
                ElseIf .Target.Position.x + .Target.Size.x / 2 < .Position.x Then
                    .Speed.x = .Speed.x - .Acceleration.x
                    If .Speed.x < -.MaxSpeed.x Then: .Speed.x = -.MaxSpeed.x
                End If
                
                If .Target.Position.y + .Target.Size.y > .Position.y Then
                    .Speed.y = .Speed.y + .Acceleration.y
                    If .Speed.y > .MaxSpeed.y Then: .Speed.y = .MaxSpeed.y
                    
                ElseIf .Target.Position.y + .Target.Size.y < .Position.y Then
                    .Speed.y = .Speed.y - .Acceleration.y
                    If .Speed.y < -.MaxSpeed.y Then: .Speed.y = -.MaxSpeed.y
                End If
            End If
        End With
        
        If Shot(A).DieTime < Temp Or Shot(A).Position.y < -48 Or Shot(A).Position.y > Camera.H + 48 Or Shot(A).Position.x < -48 Or Shot(A).Position.x > (Level.Size.x * TileW) + 48 Then
            Shot(A) = Shot(ShotCount)
            
            ShotCount = ShotCount - 1
            A = A - 1
            
        Else
            For B = 0 To ShipCount
                If B <> Shot(A).Owner Then
                    If Shot(A).Position.x + Shot(A).Size.x > Ship(B).Position.x And Shot(A).Position.x < Ship(B).Position.x + Ship(B).Size.x Then
                        If Shot(A).Position.y + Shot(A).Size.y > Ship(B).Position.y And Shot(A).Position.y < Ship(B).Position.y + Ship(B).Size.y Then
                            Hit B, A
                            
                            'Shot(A) = Shot(ShotCount)
                            'ShotCount = ShotCount - 1
                            
                            'A = A - 1
                            Exit For
                        End If
                    End If
                End If
            Next
        End If
        
        A = A + 1
    Wend
End Sub
Public Sub DrawShots()
    Dim A As Long
    
    'Disable masking
    Device.SetRenderState D3DRS_ALPHATESTENABLE, 1
    
    For A = 0 To ShotCount
        With Shot(A)
            BltToBuffer Bitmap(.Bitmap).Texture, .Position.x - Camera.x, .Position.y, CSng(.Size.x), CSng(.Size.y), Bitmap(.Bitmap).Animation.ActPhase.x * .Size.x, Bitmap(.Bitmap).Animation.ActPhase.y * .Size.y, CSng(.Size.x), CSng(.Size.y)
        End With
    Next
    
    BltBuffers
End Sub

    
Public Sub ResetShots()
    ShotCount = -1
    ReDim Shot(0)
    
    SrcShotCount = -1
    ReDim SrcShot(0)
End Sub


Public Sub LoadShots(iFilename As String)
    Dim A As Long
    Dim Temp As Long
    Dim Temp2 As String
    Dim FileNumber As Integer
    
    FileNumber = FreeFile
    
    Open Path & iFilename For Binary As FileNumber
        Get FileNumber, , SrcShotCount
        ReDim SrcShot(SrcShotCount)
        
        For A = 0 To SrcShotCount
            With SrcShot(A)
                Get FileNumber, , Temp
                Temp2 = Space(Temp)
                Get FileNumber, , Temp2
                .Bitmap = LoadBitmap(Temp2)
                
'                Get FileNumber, , Bitmap(.Bitmap).Size
                Get FileNumber, , Bitmap(.Bitmap).Animation
                
                Get FileNumber, , SrcShot(A)
            End With
        Next
    Close FileNumber
End Sub


Public Sub SaveShots(iFilename As String)
    Dim A As Long
    Dim FileNumber As Integer
    
    FileNumber = FreeFile
    
    Open Path & iFilename For Binary As FileNumber
        Put FileNumber, , SrcShotCount
        
        For A = 0 To SrcShotCount
            With SrcShot(A)
                Put FileNumber, , Len(Bitmap(.Bitmap).FileName)
                Put FileNumber, , Bitmap(.Bitmap).FileName
                
'                Put FileNumber, , Bitmap(.Bitmap).Size
                Put FileNumber, , Bitmap(.Bitmap).Animation
                
                Put FileNumber, , SrcShot(A)
            End With
        Next
    Close FileNumber
End Sub



